#!/usr/bin/bash

N_ARGS=2

usage() {
    echo -n "Usage: ${0##*/}"
    echo -n " LANG"     # $1    e.g.: en/zh_CN/ko
    echo    " SCHEME"   # $2    e.g.: http/https
}

if [ "$#" -ne "$N_ARGS" ]; then
    usage
    exit 1
fi

Q_LANG="${1}"
Q_SCHEME="${2}"

if [ "$Q_LANG" != "en" ] && [ "$Q_LANG" != "zh_CN" ] && [ "$Q_LANG" != "ko" ]; then
    Q_LANG=en
fi
if [ "$Q_SCHEME" == "https" ]; then
    Q_SCHEME=true
else
    Q_SCHEME=false
fi

if ! grep -q "General\\\\Locale=${Q_LANG}" /var/lib/qbittorrent/qBittorrent/config/qBittorrent.conf || ! grep -q "WebUI\\\\HTTPS\\\\Enabled=${Q_SCHEME}" /var/lib/qbittorrent/qBittorrent/config/qBittorrent.conf; then
    systemctl stop qbittorrent-unas.service

    sed -i -e "s/^General\\\\Locale=.*$/General\\\\Locale=${Q_LANG}/" -e "s/^WebUI\\\\HTTPS\\\\Enabled=.*$/WebUI\\\\HTTPS\\\\Enabled=${Q_SCHEME}/" /var/lib/qbittorrent/qBittorrent/config/qBittorrent.conf

    rm -f /unas/etc/apache2/apps/desktop/http/qbittorrent.conf || :
    rm -f /unas/etc/apache2/apps/desktop/https/qbittorrent.conf || :
    if [ "$Q_SCHEME" == "true" ]; then
        ln -s /unas/etc/qbittorrent/ReverseProxySSL.conf /unas/etc/apache2/apps/desktop/https/qbittorrent.conf
    else
        ln -s /unas/etc/qbittorrent/ReverseProxy.conf /unas/etc/apache2/apps/desktop/http/qbittorrent.conf
    fi

    systemctl start qbittorrent-unas.service
    systemctl reload apache2.service
    sleep 1
fi
